## alsa-scarlett-gui 0.4.0

=== Makefile ===
NAME := alsa-scarlett-gui
VERSION := $(shell git describe --abbrev=4 --always --tags | sed 's/-/./g')
NAMEVER := $(NAME)-$(VERSION)
TAR_FILE := $(NAMEVER).tar
TARGZ_FILE := $(TAR_FILE).gz
SPEC_FILE := $(NAME).spec

default:
	@echo "alsa-scarlett-gui"
	@echo
	@echo "If you want to build and install from source, please try:"
	@echo "  cd src"
	@echo "  make -j4"
	@echo "  sudo make install"
	@echo
	@echo "This Makefile knows about packaging:"
	@echo "  make tar"
	@echo "  make rpm"

tar: $(TARGZ_FILE)

$(TARGZ_FILE):
	git archive --format=tar --prefix=$(NAMEVER)/ HEAD > $(TAR_FILE)
	sed 's_VERSION$$_$(VERSION)_' < $(SPEC_FILE).template > $(SPEC_FILE)
	tar --append -f $(TAR_FILE) \
		--transform s_^_$(NAMEVER)/_ \
		--owner=root --group=root \
		$(SPEC_FILE)
	rm -f $(SPEC_FILE)
	gzip < $(TAR_FILE) > $(TARGZ_FILE)
	rm -f $(TAR_FILE)

rpm: $(TARGZ_FILE)
	rpmbuild -tb $(TARGZ_FILE)

=== src/Makefile ===
# SPDX-FileCopyrightText: 2022-2024 Geoffrey D. Bennett <g@b4.vu>
# SPDX-License-Identifier: GPL-3.0-or-later

# Credit to Tom Tromey and Paul D. Smith:
# http://make.mad-scientist.net/papers/advanced-auto-dependency-generation/

VERSION := $(shell \
  git describe --abbrev=4 --dirty --always --tags 2>/dev/null || \
  echo $${APP_VERSION:-Unknown} \
)

DEPDIR := .deps
DEPFLAGS = -MT $@ -MMD -MP -MF $(DEPDIR)/$*.d

CFLAGS ?= -ggdb -fno-omit-frame-pointer -O2
CFLAGS += -Wall -Werror -D_FORTIFY_SOURCE=2
CFLAGS += -DVERSION=\"$(VERSION)\"
CFLAGS += -Wno-error=deprecated-declarations

PKG_CONFIG=pkg-config

CFLAGS += $(shell $(PKG_CONFIG) --cflags glib-2.0)
CFLAGS += $(shell $(PKG_CONFIG) --cflags gtk4)
CFLAGS += $(shell $(PKG_CONFIG) --cflags alsa)

LDFLAGS += $(shell $(PKG_CONFIG) --libs glib-2.0)
LDFLAGS += $(shell $(PKG_CONFIG) --libs gtk4)
LDFLAGS += $(shell $(PKG_CONFIG) --libs alsa)
LDFLAGS += -lm -lcrypto

COMPILE.c = $(CC) $(DEPFLAGS) $(CFLAGS) -c

%.c: %.xml $(DEPDIR)/%-xml.d | $(DEPDIR)
	echo $@: $(shell $(GLIB_COMPILE_RESOURCES) $< --generate-dependencies) > $(DEPDIR)/$*-xml.d
	$(GLIB_COMPILE_RESOURCES) $< --target=$@ --generate-source

XML_SRC := $(wildcard *.xml)
XML_OBJ := $(patsubst %.xml,%.c,$(XML_SRC))

%.o: %.c
%.o: %.c Makefile $(DEPDIR)/%.d | $(DEPDIR)
	$(COMPILE.c) $(OUTPUT_OPTION) $<

SRCS := $(sort $(wildcard *.c) $(XML_OBJ))
OBJS := $(patsubst %.c,%.o,$(SRCS))
TARGET := alsa-scarlett-gui
DOMAIN_PREFIX := vu.b4
DESKTOP_FILE := $(DOMAIN_PREFIX).$(TARGET).desktop
ICON_FILE := $(DOMAIN_PREFIX).$(TARGET).png

GLIB_COMPILE_RESOURCES := $(shell $(PKG_CONFIG) --variable=glib_compile_resources gio-2.0)

all: $(TARGET) $(DESKTOP_FILE)

clean:
	rm -f $(TARGET) $(DESKTOP_FILE) $(OBJS) $(XML_OBJ)

depclean:
	rm -rf $(DEPDIR)

$(DEPDIR): ; @mkdir -p $@

DEPFILES := $(SRCS:%.c=$(DEPDIR)/%.d) $(XML_SRC:%.xml=$(DEPDIR)/%-xml.d)
$(DEPFILES):

include $(wildcard $(DEPFILES))

$(TARGET): $(OBJS)
	cc -o $(TARGET) $(OBJS) ${LDFLAGS}

ifeq ($(PREFIX),)
  PREFIX := /usr/local
endif

BINDIR := $(DESTDIR)$(PREFIX)/bin
ICONTOP := $(DESTDIR)$(PREFIX)/share/icons/hicolor
ICONDIR := $(ICONTOP)/256x256/apps
DESKTOPDIR := $(DESTDIR)$(PREFIX)/share/applications

$(DESKTOP_FILE): $(DESKTOP_FILE).template
	sed 's_PREFIX_$(PREFIX)_' < $< > $@

install: all
	install -d $(BINDIR)
	install -m 755 $(TARGET) $(BINDIR)
	install -d $(ICONDIR)
	install -m 644 img/$(ICON_FILE) $(ICONDIR)
	install -d $(DESKTOPDIR)
	install -m 644 $(DESKTOP_FILE) $(DESKTOPDIR)

uninstall:
	rm -f $(BINDIR)/$(TARGET)
	rm -f $(ICONDIR)/$(ICON_FILE)
	rm -f $(DESKTOPDIR)/$(DESKTOP_FILE)

help:
	@echo "alsa-scarlett-gui"
	@echo
	@echo "This Makefile knows about:"
	@echo "  make"
	@echo "  make install"
	@echo "  make uninstall"

=== debian/changelog ===
alsa-scarlett-gui (0.4.0-1) unstable; urgency=medium

  * New upstream version 0.4.0
    - Routing window can now be resized and will scroll as you drag.
    - Main window is taller and narrower for larger interfaces without
      speaker switching.
    - Level meters are now read-only.
    - CFLAGS from the environment is now respected during build, ensuring that
      hardening flags are correctly passed to the compiler.
    - Reworked UI with custom theme.
    - Support for Scarlett 4th Gen and Vocaster
    - Support for firmware update (with kernel 6.8+ or updated snd-usb-audio
      protocol driver)
    - Support for config reset
    - Updated documentation

  * Packaging changes:
    - INSTALL.md: Remove build instructions
    - d/control: build only for Linux targets, since this application depends
      on the Scarlett mixer driver shipped with the Linux kernel.
    - Add superficial autopkgtest to check installation and execution.
    - Add salsa-ci.yml for build testing.
    - Remove multiarch and disable salsa-ci crossbuild test, due to a dependency
      on gobject-introspection.
    - Include examples from demo/ directory for use in interface simulation
      mode.
    - Include upstream documentation files.
    - Add build-depends on libssl-dev
    - Bump copyright year
    - Bump Standards-Version to 4.7.0, no changes needed.

 -- Dale Richards <dale@dalerichards.net>  Fri, 12 Apr 2024 09:09:59 +0100

alsa-scarlett-gui (0.3.2-1) unstable; urgency=low

  * Initial release. Closes: #1036223
  * Add basic man page.

 -- Dale Richards <dale@dalerichards.net>  Mon, 20 Nov 2023 10:19:23 +0000

=== debian/control ===
Source: alsa-scarlett-gui
Section: sound
Priority: optional
Maintainer: Dale Richards <dale@dalerichards.net>
Build-Depends: debhelper-compat (= 13),
 libasound2-dev,
 libgtk-4-dev,
 libssl-dev,
Standards-Version: 4.7.0
Homepage: https://github.com/geoffreybennett/alsa-scarlett-gui
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/doge-tech/alsa-scarlett-gui.git
Vcs-Browser: https://salsa.debian.org/doge-tech/alsa-scarlett-gui

Package: alsa-scarlett-gui
Architecture: linux-any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Gtk4 GUI for the Focusrite Scarlett/Clarett ALSA controls
 This package contains a Gtk4 GUI for the ALSA controls
 exposed by the Focusrite Scarlett/Clarett kernel driver

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

# export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,-O1
export PREFIX = /usr

%:
	dh $@ -Dsrc

override_dh_auto_build:
	dh_auto_build -- VERSION=$(DEB_VERSION)

## alsa-scarlett-gui 0.5.1

=== src/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# SPDX-FileCopyrightText: 2022-2024 Geoffrey D. Bennett <g@b4.vu>
+# SPDX-FileCopyrightText: 2022-2025 Geoffrey D. Bennett <g@b4.vu>
 # SPDX-License-Identifier: GPL-3.0-or-later
 
 # Credit to Tom Tromey and Paul D. Smith:
@@ -12,8 +12,9 @@
 DEPDIR := .deps
 DEPFLAGS = -MT $@ -MMD -MP -MF $(DEPDIR)/$*.d
 
-CFLAGS ?= -ggdb -fno-omit-frame-pointer -O2
-CFLAGS += -Wall -Werror -D_FORTIFY_SOURCE=2
+CFLAGS ?= -ggdb -fno-omit-frame-pointer -fPIE -O2
+CFLAGS += -Wall -Werror
+CFLAGS += -U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=3
 CFLAGS += -DVERSION=\"$(VERSION)\"
 CFLAGS += -Wno-error=deprecated-declarations
 
@@ -26,7 +27,7 @@
 LDFLAGS += $(shell $(PKG_CONFIG) --libs glib-2.0)
 LDFLAGS += $(shell $(PKG_CONFIG) --libs gtk4)
 LDFLAGS += $(shell $(PKG_CONFIG) --libs alsa)
-LDFLAGS += -lm -lcrypto
+LDFLAGS += -lm -lcrypto -pie
 
 COMPILE.c = $(CC) $(DEPFLAGS) $(CFLAGS) -c
 
@@ -52,7 +53,7 @@
 
 all: $(TARGET) $(DESKTOP_FILE)
 
-clean:
+clean: depclean
 	rm -f $(TARGET) $(DESKTOP_FILE) $(OBJS) $(XML_OBJ)
 
 depclean:
@@ -66,7 +67,7 @@
 include $(wildcard $(DEPFILES))
 
 $(TARGET): $(OBJS)
-	cc -o $(TARGET) $(OBJS) ${LDFLAGS}
+	$(CC) -o $(TARGET) $(OBJS) ${LDFLAGS}
 
 ifeq ($(PREFIX),)
   PREFIX := /usr/local

=== debian/changelog ===
alsa-scarlett-gui (0.5.1-1) unstable; urgency=medium

  * New upstream version 0.5.1
    - Add support for 1st Gen (6i6, 8i6, 18i6, 18i8, 18i20) and big 4th Gen
      (16i16, 18i16, 18i20) interfaces.
  * Bump Standards-Version to 4.7.2 (no changes required).
  * Bump copyright year.

 -- Dale Richards <dale@dalerichards.net>  Thu, 20 Mar 2025 13:56:03 +0000

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
  libasound2-dev,
  libgtk-4-dev,
  libssl-dev,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/geoffreybennett/alsa-scarlett-gui
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/doge-tech/alsa-scarlett-gui.git

=== debian/tests/control ===
Test-Command: alsa-scarlett-gui --help
Depends: @
Restrictions: superficial

=== debian/watch ===
version=4
opts="searchmode=plain,\
filenamemangle=s%.*/v?@ANY_VERSION@%@PACKAGE@-$1.tar.gz%" \
https://api.github.com/repos/geoffreybennett/alsa-scarlett-gui/releases?per_page=50 \
https://api.github.com/repos/[^/]+/[^/]+/tarball/v?@ANY_VERSION@
